#!/bin/bash
# {{ ansible_managed }}
#
# Set alias {{ elasticsearch_oer_index_alias_name }} for current index that is defined in "oersi_backend_config".
# Also remove old aliases and indices.
#


CURRENT_INDEX_NAME=$(curl --netrc-file {{ base_dir }}/conf/oer_index_access http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/oersi_backend_config/_doc/oersi_backend_config/_source/ | jq -r .metadataIndexName)
CURRENT_INDEX_INTERNAL_NAME=$(curl --netrc-file {{ base_dir }}/conf/oer_index_access http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/oersi_backend_config/_doc/oersi_backend_config/_source/ | jq -r .additionalMetadataIndexName)
date +"*** %Y-%m-%d %H:%M:%S start update alias to current index $CURRENT_INDEX_NAME"

update() {
  date +"*** %Y-%m-%d %H:%M:%S retrieve existing aliases"
  OLD_ALIASES=$(curl --netrc-file {{ base_dir }}/conf/oer_index_access -X GET "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/_cat/aliases/$2?format=json&h=index")
  OLD_ALIASES=$(echo $OLD_ALIASES | jq "del(.[] | select(.index == \"$1\"))")

  ALIASES_UPDATE="{\"actions\": []}"
  for INDEX in $(echo $OLD_ALIASES | jq -r '.[] | .index'); do
    ALIASES_UPDATE=$(echo $ALIASES_UPDATE | jq ".actions += [{\"remove\": {\"index\": \"$INDEX\", \"alias\": \"$2\"}}]")
  done
  ALIASES_UPDATE=$(echo $ALIASES_UPDATE | jq ".actions += [{\"add\": {\"index\": \"$1\", \"alias\": \"$2\"}}]")
  date +"*** %Y-%m-%d %H:%M:%S process aliases update"
  echo $ALIASES_UPDATE | jq -r '.'
  curl --netrc-file {{ base_dir }}/conf/oer_index_access -X POST --header 'Content-Type: application/json' "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/_aliases" -d "$ALIASES_UPDATE"

  for INDEX in $(echo $OLD_ALIASES | jq -r '.[] | .index'); do
    date +"*** %Y-%m-%d %H:%M:%S removing old index $INDEX"
    curl --netrc-file {{ base_dir }}/conf/oer_index_access -X DELETE "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/$INDEX"
  done
}

update $CURRENT_INDEX_NAME {{ elasticsearch_oer_index_alias_name }}
update $CURRENT_INDEX_INTERNAL_NAME {{ elasticsearch_oer_index_internal_alias_name }}
